/*
	Mges.dll̑֌W
*/

#include <windows.h>
#include <stdio.h>
#include <shlwapi.h>	/*	PathRemoveFileSpec() ̂	*/

#include "mges.h"


#ifdef __cplusplus	/*	c Ȃ̂ňӖ͖	*/
extern "C" {
#endif

typedef HANDLE (WINAPI *mgesInitialize)(LPCSTR lpcIniFile, const HWND hOwner, const UINT nNotify1, const UINT nNotify2, const BOOL fAutoCheck, const DWORD dwDisableSKey);
typedef BOOL (WINAPI *mgesTranslate)(const HANDLE hMges, const HWND hWnd, const UINT message, const WPARAM wParam, const LPARAM lParam);
typedef BOOL (WINAPI *mgesAddGesture)(const HANDLE hMges, const DWORD* lpdwGesture, const UINT nNum, const BOOL fDefault, LPCSTR lpcIniFile, const int iMode);
typedef BOOL (WINAPI *mgesUpdateMenuString)(const HANDLE hMges, HMENU hMenu);
typedef void (WINAPI *mgesCloseHandle)(const HANDLE hMges);
typedef int (WINAPI *mgesConfigDialog)(const HWND hWnd, LPCSTR lpcIniFile, LPCSTR lpcLstFile, const DWORD dwDisableSKey, const HANDLE hMges);

#ifdef __cplusplus
}
#endif


static HMODULE			hDLL_	= NULL;				/*	Mges.dll	*/
static HANDLE			hMges_	= NULL;				/*	mges nh	*/
static mgesTranslate	pfnTranslate_	= NULL;		/*	mgesTranslate() ̊֐|C^ */
static char				cMgesIni_[_MAX_PATH];		/*	mges.ini t@CpX	*/


/*==============================================================
//	Mges 
//============================================================*/
BOOL MgesInitialize(									/*OUT	:	*/
	const HWND hWnd										/*IN	:EBhEnh	*/
)
{
	char				cPath[_MAX_PATH];
	mgesInitialize		pfnInitialize;

	/*	sample.exe ƓtH_ɍ݂ Mges.dll ̃tpX擾	*/
	GetModuleFileName(NULL, cPath, _MAX_PATH);
	PathRemoveFileSpec(cPath);
	strcat(cPath, "\\Mges.dll");

	hDLL_	= LoadLibrary(cPath);
	if (hDLL_ != NULL) {
		pfnInitialize	= (mgesInitialize)GetProcAddress(hDLL_, "mgesInitialize");
		if (pfnInitialize != NULL) {
			/*	Mges.dll ƓtH_ɍ݂ sample.iniimges.ini t@Cj̃tpX擾	*/
			PathRemoveFileSpec(cPath);
			sprintf(cMgesIni_, "%s\\sample.ini", cPath);
			/*	mges nh쐬	*/
			hMges_	= pfnInitialize(cMgesIni_, hWnd, UM_MGES_COMMAND, UM_MGES_STRING, TRUE, 0L);
			if (hMges_ != NULL) {
				/*	mgesTranslate()	֐̃AhX擾	*/
				pfnTranslate_	= (mgesTranslate)GetProcAddress(hDLL_, "mgesTranslate");
				if (pfnTranslate_ != NULL) {
					/*		*/
					return TRUE;
				}
			}
		}
	}
	/*	s	*/
	MgesRelease();
	return FALSE;
}
/*==============================================================
//	Mges I
//============================================================*/
void MgesRelease()
{
	pfnTranslate_		= NULL;
	MgesCloseHandle();
	if (hDLL_ != NULL) {
		FreeLibrary(hDLL_);
		hDLL_			= NULL;
	}
}
/*==============================================================
//	Mges WFX`[bZ[W̏
//============================================================*/
BOOL MgesTranslate(										/*OUT	:TRUE=bZ[WAFALSE=	*/
	const LPMSG lpMsg									/*IN	:bZ[W	*/
)
{
	return (hMges_ != NULL && pfnTranslate_ != NULL &&
		pfnTranslate_(hMges_, lpMsg->hwnd, lpMsg->message, lpMsg->wParam, lpMsg->lParam));
}
/*==============================================================
//	W̃WFX`[ݒ
//============================================================*/
void MgesSetDefaultGesture(
	DWORD dwGesture[],									/*IN	:WFX`[	*/
	const UINT nNum,									/*IN	:WFX`[	*/
	const BOOL fMouse									/*IN	:true=}EXWFX`[ݒAfalse=L[{[hWFX`[ݒ	*/
)
{
	mgesAddGesture		pfnAddGesture;

	if (hDLL_ != NULL && hMges_ != NULL) {
		pfnAddGesture	= (mgesAddGesture)GetProcAddress(hDLL_, "mgesAddGesture");
		if (pfnAddGesture != NULL) {
			/*	4 TRUE w肷ƍŏ̋Nimges.ini ɗLȏ񂪑݂Ȃĵ
				w̃WFX`[ݒ肳ĩWFX`[ݒ肪݂鎞͍XVȂj*/
			pfnAddGesture(hMges_, dwGesture, nNum, TRUE, cMgesIni_, fMouse ? 0 : 1);
		}
	}
}
/*==============================================================
//	j[̕\LXV
//============================================================*/
void MgesUpdateMenuString(
	const HMENU hMenu									/*IN	:j[nh	*/
)
{
	mgesUpdateMenuString	pfnUpdateMenuString;

	if (hDLL_ != NULL && hMges_ != NULL) {
		pfnUpdateMenuString	= (mgesUpdateMenuString)GetProcAddress(hDLL_, "mgesUpdateMenuString");
		if (pfnUpdateMenuString != NULL) {
			pfnUpdateMenuString(hMges_, hMenu);
		}
	}
}
/*==============================================================
//	Mges nhJ
//============================================================*/
void MgesCloseHandle()
{
	mgesCloseHandle		pfnCloseHandle;

	if (hDLL_ != NULL && hMges_ != NULL) {
		pfnCloseHandle	= (mgesCloseHandle)GetProcAddress(hDLL_, "mgesCloseHandle");
		if (pfnCloseHandle != NULL) {
			pfnCloseHandle(hMges_);
			hMges_	= NULL;
		}
	}
}
/*==============================================================
//	Mges RtBO_CAO\
//============================================================*/
BOOL MgesConfigDialog(									/*OUT	:TRUE=ύXꂽAFALSE=LZꂽior Errorj	*/
	const HWND hWnd										/*IN	:EBhEnh	*/
)
{
	mgesConfigDialog	pfnConfigDialog;

	if (hDLL_ != NULL && hMges_ != NULL) {
		pfnConfigDialog	= (mgesConfigDialog)GetProcAddress(hDLL_, "mgesConfigDialog");
		if (pfnConfigDialog != NULL && cMgesIni_[0] != '\0') {
			return (pfnConfigDialog(hWnd, cMgesIni_, NULL, 0L, hMges_) == 0);
		}
	}
	return FALSE;
}
